Bug 484105 - [IPV6] Return correct result for sticky options
[IPV6] Return correct result for sticky options
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
medium Severity medium
: rc
: ---
Assigned To: Jiri Pirko
Red Hat Kernel QE team
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-04 14:47 EST by Dave Maley
Modified: 2015-05-04 21:16 EDT (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 04:49:00 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
reproducer (1.18 KB, text/plain)
2009-02-04 14:51 EST, Dave Maley
no flags Details
patch provided by partner (1.20 KB, patch)
2009-02-04 14:53 EST, Dave Maley
no flags Details | Diff

  None (edit)
Description Dave Maley 2009-02-04 14:47:33 EST
Description of problem:
When use getsockopt() with option 'IPV6_DSTOPTS', kernel should return the actual copied option length instead of the length 0.


Version-Release number of selected component (if applicable):
2.6.18-128.EL


How reproducible:
every time


Steps to Reproduce:
(see reproducer)
1. # gcc -o dstopt-7 dstopt-7.c
2. # ./dstopt-7
3.
  

Actual results:
Option length is set to 0

 Reproduce program log.
 # ./dstopt-7
 == create an IPv6 socket ==
 == set Destination options header. optlen: 8 ==
 == get Destination options header ==
 == check length of Destination options header ==
 ERROR: getsockopt IPV6_DSTOPTS return bad length: 0
 <=====NG=====>


Expected results:
Option length is set to the actual copied option length 8


Additional info:
The reproduction program: dstopt-7.c

The patch file is attached: file: net-fix-return-option-length-of-getsockopt.patch

options 'IPV6_HOPOPTS', 'IPV6_RTHDRDSTOPTS' and 'IPV6_RTHDR' have similar problems. So we also correct them in this patch.

This patch has already been applied for the Community's kernel.
Comment 1 Dave Maley 2009-02-04 14:51:44 EST
Created attachment 330910 [details]
reproducer

# gcc -o dstopt-7 dstopt-7.c
# ./dstopt-7
Comment 2 Dave Maley 2009-02-04 14:53:04 EST
Created attachment 330911 [details]
patch provided by partner

upstream info:
commit 4c6510a738c71ca6b4b7b624a7d0a00acebfd7fb
Author: YOSHIFUJI Hideaki <yoshfuji@linux-ipv6.org>
Date:   Sun Mar 18 17:35:57 2007 -0700
Comment 5 RHEL Product and Program Management 2009-02-16 10:34:28 EST
Updating PM score.
Comment 6 Don Zickus 2009-03-09 14:55:14 EDT
in kernel-2.6.18-134.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 9 Chris Ward 2009-07-03 14:23:28 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 10 Chris Ward 2009-07-10 15:10:31 EDT
~~ Attention Partners - RHEL 5.4 Snapshot 1 Released! ~~

RHEL 5.4 Snapshot 1 has been released on partners.redhat.com. If you have already reported your test results, you can safely ignore this request. Otherwise, please notice that there should be a fix available now that addresses this particular request. Please test and report back your results here, at your earliest convenience. The RHEL 5.4 exception freeze is quickly approaching.

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Do not flip the bug status to VERIFIED. Instead, please set your Partner ID in the Verified field above if you have successfully verified the resolution of this issue. 

Further questions can be directed to your Red Hat Partner Manager or other appropriate customer representative.
Comment 13 errata-xmlrpc 2009-09-02 04:49:00 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.